// PhotoRedaterDlg.cpp : implementation file
//

#include "stdafx.h"
#include "PhotoRedater.h"
#include "PhotoRedaterDlg.h"
#include "ShowResultsDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPhotoRedaterDlg dialog

CPhotoRedaterDlg::CPhotoRedaterDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPhotoRedaterDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPhotoRedaterDlg)
	m_DeltaHours = 0;
	m_DeltaMinutes = 0;
	m_DeltaSeconds = 0;
	m_FileList = _T("");
	m_AddOrSubtract = 0;
	m_CameraInitials = theApp.m_CameraInitials;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CPhotoRedaterDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPhotoRedaterDlg)
	DDX_Text(pDX, IDC_EDIT_HOURS, m_DeltaHours);
	DDV_MinMaxInt(pDX, m_DeltaHours, 0, 24);
	DDX_Text(pDX, IDC_EDIT_MINUTES, m_DeltaMinutes);
	DDV_MinMaxInt(pDX, m_DeltaMinutes, 0, 59);
	DDX_Text(pDX, IDC_EDIT_SECONDS, m_DeltaSeconds);
	DDV_MinMaxInt(pDX, m_DeltaSeconds, 0, 59);
	DDX_Text(pDX, IDC_EDIT_FILENAMELIST, m_FileList);
	DDX_Radio(pDX, IDC_RADIO_ADD, m_AddOrSubtract);
	DDX_Text(pDX, IDC_EDIT_CAMERA_INITIALS, m_CameraInitials);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPhotoRedaterDlg, CDialog)
	//{{AFX_MSG_MAP(CPhotoRedaterDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_BROWSE, OnButtonBrowse)
	ON_BN_CLICKED(IDC_BUTTON_BROWSE_MORE, OnButtonBrowseMore)
	ON_BN_CLICKED(IDC_BUTTON_HELP, OnButtonHelp)
	ON_BN_CLICKED(IDC_BUTTON_DO_RENAME, OnButtonDoRename)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPhotoRedaterDlg message handlers

BOOL CPhotoRedaterDlg::OnInitDialog()
{
	CEdit *pFileListEditBox;

	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	pFileListEditBox = (CEdit*) GetDlgItem(IDC_EDIT_FILENAMELIST);
	if (pFileListEditBox != NULL)
		pFileListEditBox->SetLimitText(0); // No limit, maximum size as system allows.

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CPhotoRedaterDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
// to draw the icon.  For MFC applications using the document/view model,
// this is automatically done for you by the framework.

void CPhotoRedaterDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CPhotoRedaterDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


void CPhotoRedaterDlg::OnButtonBrowse()
{
	PromptForFileNamesAndCopyToList(false /* don't append */);
}


void CPhotoRedaterDlg::OnButtonBrowseMore() 
{
	PromptForFileNamesAndCopyToList(true /* append */);
}


int CompareCStringPointers( const void *arg1, const void *arg2 )
{
	CString *String1 = *(CString **) arg1;
	CString *String2 = *(CString **) arg2;

	return String1->CompareNoCase(*String2);
}


void CPhotoRedaterDlg::PromptForFileNamesAndCopyToList(bool AppendMode)
{
	const int BufferSize = 50000000;

	if (!UpdateData(TRUE))
		return; // Failed to copy dialog box values into the variables.

	CFileDialog FileDialog ( TRUE /* bOpenFileDialog */,
		NULL /* lpszDefExt */,
		NULL /* lpszFileName */,
		OFN_ALLOWMULTISELECT | OFN_EXPLORER | OFN_FILEMUSTEXIST |
		OFN_PATHMUSTEXIST | OFN_HIDEREADONLY | OFN_NOCHANGEDIR /* dwFlags */,
		"Photos (*.jpg, *.jpeg)|*.JPG;*.JPEG|"
		"Thumbnails (*.thm)|*.THM|"
		"Movies (*.avi)|*.AVI|"
		"All Files (*.*)|*.*||" /* lpszFilter */,
		this /* pParentWnd */);
	FileDialog.m_ofn.lpstrTitle = "Select Files to Redate";
	FileDialog.m_ofn.nFilterIndex = 4; // Default to filter for "*.*".

	TCHAR *FileNameString = new TCHAR[BufferSize];
	FileNameString[0] = 0;
	FileDialog.m_ofn.lpstrFile = FileNameString;
	FileDialog.m_ofn.nMaxFile = BufferSize;
	FileDialog.m_ofn.lpstrInitialDir = theApp.m_PreferedDirectory;

	if (FileDialog.DoModal() != IDCANCEL)
	{
		POSITION CurrentIndex;
		int NumberOfPathNames;
		CString PathName;

		if (!AppendMode)
			m_FileList.Empty();

		// Count the path names.

		NumberOfPathNames = 0;
		CurrentIndex = FileDialog.GetStartPosition();
		while (CurrentIndex != NULL)
		{
			FileDialog.GetNextPathName (CurrentIndex);
			NumberOfPathNames++;
		}

		if (NumberOfPathNames > 0)
		{
			int i;
			CString *PathNamePntr;
			CString **SortedPathNamesArray = new CString* [NumberOfPathNames];

			// Copy the path names out of the buffer and into the array.

			CurrentIndex = FileDialog.GetStartPosition();
			i = 0;
			while (CurrentIndex != NULL && i < NumberOfPathNames)
			{
				PathName = FileDialog.GetNextPathName (CurrentIndex);
				SortedPathNamesArray[i] = new CString (PathName);
				i++;
			}

			// Sort the array by swapping pointers with Quicksort.

			qsort(SortedPathNamesArray, NumberOfPathNames, sizeof (CString *),
				CompareCStringPointers);
			
			// Copy all the sorted names from the array to the file list string.

			i = 0;
			while (i < NumberOfPathNames)
			{
				PathNamePntr = SortedPathNamesArray[i];

				if (!m_FileList.IsEmpty())
					m_FileList += "\r\n";
				else // First file name, save the path as the new default.
				{
					int Index;
					Index = PathNamePntr->ReverseFind('\\');
					if (Index < 0)
						Index = PathNamePntr->ReverseFind('/');
					if (Index < 0)
						Index = PathNamePntr->ReverseFind(':');
					if (Index < 0)
						theApp.m_PreferedDirectory = _T("");
					else // Includes trailing slash.
						theApp.m_PreferedDirectory = PathNamePntr->Left(Index+1);
				}

				m_FileList += *PathNamePntr;
				delete SortedPathNamesArray[i];
				i++;
			}
		
			delete [] SortedPathNamesArray;
		}

		UpdateData(FALSE); // Copy variables back to dialog box.
	}
	delete[] FileNameString;
}


void CPhotoRedaterDlg::OnButtonHelp()
{
	OnSysCommand(IDM_ABOUTBOX, 0);
}


void CPhotoRedaterDlg::OnOK()
{
	ProcessFileNames(false /* DoActualRenameOperation */);
	
	// Don't call CDialog::OnOK(), it exits the main dialog box and kills the
	// event loop too.
}


void CPhotoRedaterDlg::OnButtonDoRename() 
{
	if (MessageBox (
	_T("Are you sure you want to rename the files?\r\n\r\n"
		"As soon as you select OK, the renaming will start,\r\n"
		"and you won't be able to undo it!  Though if you're\r\n"
		"quick, you can close the window before it gets too far."),
	_T("Last chance to avoid Renaming Files"),
	MB_ICONWARNING | MB_OKCANCEL | MB_DEFBUTTON2) == 1)
	{
		ProcessFileNames(true /* DoActualRenameOperation */);
	}
}


void CPhotoRedaterDlg::ProcessFileNames(bool DoActualRenameOperation)
{
	CTimeSpan DeltaTime;

	if (!UpdateData(TRUE))
		return; // Failed to copy dialog box values into the variables.
	theApp.m_CameraInitials = m_CameraInitials;

	if (m_AddOrSubtract == 1)
		DeltaTime = CTimeSpan ( 0 /* days */, -m_DeltaHours, -m_DeltaMinutes, -m_DeltaSeconds);
	else
		DeltaTime = CTimeSpan ( 0 /* days */, m_DeltaHours, m_DeltaMinutes, m_DeltaSeconds);

	// Make the results dialog box, fill it with the file names,
	// show it, then destroy it.

	ShowResultsDlg ResultsDialog (DoActualRenameOperation
		? ShowResultsDlg::SM_DO_RENAME_OPERATION
		: ShowResultsDlg::SM_SHOW_BATCH_COMMANDS,
		this /* Parent window */);

	if (!DoActualRenameOperation)
	{
		ResultsDialog.AppendText(
			"REM Here are the commands needed to rename your files to have names\r\n"
			"REM which include the corrected time stamp from the file.  To use\r\n"
			"REM this, copy all the text and paste it into a text editor and use\r\n"
			"REM search and replace to remove the REM in front of the lines you\r\n"
			"REM want to use, and edit the paths if needed.  For example,\r\n"
			"REM change 'REM copy' to 'copy' to activate the copy commands,\r\n"
			"REM while making sure the 'ren' commands are REMed out.  Or try\r\n"
			"REM changing '\" \"D:\\OldPath' to '\" \"E:\\NewPath' to change the\r\n"
			"REM destination path to NewPath (specifying the two double quotes\r\n"
			"REM makes it change just the second path in the command).\r\n"
			"REM Then copy and paste the results into a command window to run it.\r\n\r\n");
	}
	ResultsDialog.AppendText(
		"REM PhotoRedater version 1.0,\r\n"
		"REM authored by Alexander G. M. Smith, agmsmith@ncf.ca,\r\n"
		"REM last compiled on " __DATE__ " at " __TIME__ ",\r\n"
		"REM output generated on ");
	ResultsDialog.AppendText(CTime::GetCurrentTime().Format("%#c"));
	ResultsDialog.AppendText(".\r\n\r\n");

	// Spin through the file names and add each one individually to
	// the results dialog box, which will do the processing later.

	LPTSTR DestPntr;
	LPCTSTR SourcePntr;
	const unsigned int FileNameSize = 2048;
	TCHAR FileName[FileNameSize];
	SourcePntr = m_FileList;
	while (*SourcePntr != 0)
	{
		// Skip leading spaces and new lines.

		if (*SourcePntr == '\r' || *SourcePntr == '\n' || isspace (*SourcePntr))
		{
			SourcePntr++;
			continue;
		}

		// Extract the path name, everything up to the end of the line.

		DestPntr = FileName;
		while (*SourcePntr != 0 && *SourcePntr != '\r' && *SourcePntr != '\n' &&
		DestPntr < FileName + (FileNameSize - 1))
		{
			*DestPntr++ = *SourcePntr++;
		}
		*DestPntr = 0;

		ResultsDialog.AddFileName (FileName, m_CameraInitials, DeltaTime);
	}

	ResultsDialog.DoModal(); // Show the results, lets the user copy them.
}
